力扣刷题--2965. 找出缺失和重复的数字【简单】

题目描述

给你一个下标从 0 开始的二维整数矩阵 grid,大小为 n * n ,其中的值在 1, n2 范围内。除了 a 出现 两次,b 缺失 之外,每个整数都 恰好出现一次 。

任务是找出重复的数字a 和缺失的数字 b 。

返回一个下标从 0 开始、长度为 2 的整数数组 ans ,其中 ans0 等于 a ,ans1 等于 b 。

示例 1:

输入:grid = \[1,3,2,2]

输出:2,4

解释:数字 2 重复,数字 4 缺失,所以答案是 2,4 。

示例 2:

输入:grid = \[9,1,7,8,9,2,3,4,6]

输出:9,5

解释:数字 9 重复,数字 5 缺失,所以答案是 9,5 。

提示:

2 <= n == grid.length == gridi.length <= 50

1 <= gridij <= n * n

对于所有满足1 <= x <= n * n 的 x ,恰好存在一个 x 与矩阵中的任何成员都不相等。

对于所有满足1 <= x <= n * n 的 x ,恰好存在一个 x 与矩阵中的两个成员相等。

除上述的两个之外,对于所有满足1 <= x <= n * n 的 x ,都恰好存在一对 i, j 满足 0 <= i, j <= n - 1 且 gridij == x 。

算法分析

先把二维数组的值全部放入一个一维数组当中,然后排序,如果相邻元素相等,就是重复的数字,然后遍历1-n*n中的数字,看他是否在一维数组当中。

完整代码

cpp 复制代码
class Solution {
public:
    vector<int> findMissingAndRepeatedValues(vector<vector<int>>& grid) {
        vector<int>arr;
        vector<int>ans;
        int n=grid.size();
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<n;j++)
                arr.push_back(grid[i][j]);  
        }
        sort(arr.begin(),arr.end());
        //重复的数字
        for(int i=0;i+1<arr.size();i++)
        {
            if(arr[i]==arr[i+1])
                ans.push_back(arr[i]);
        }
        //丢失的数字
        for(int i=1;i<=n*n;i++)
        {
            if(find(arr.begin(),arr.end(),i)==arr.end())
                ans.push_back(i);
        }
        return ans;
    }
};
相关推荐
吴可可12333 分钟前
Accumark二次开发环境搭建与API入门
算法
.道阻且长.35 分钟前
Linux 基本开发工具:编辑器vim,配置vim
linux·运维·服务器·职场和发展·编辑器·vim·1024程序员节
文丑颜不良啊37 分钟前
LeetCode701~725题目解析
java·leetcode
木井巳2 小时前
【动态规划: 线性dp】解码方法
java·算法·leetcode·动态规划·推荐算法
春弦_10 小时前
自用算法整理二
数据结构·算法·图论
背调合规知识库10 小时前
数据授权中处理目的、方式与信息种类核验什么?方法、证据与误区
职场和发展
hetao173383711 小时前
2026-10-22~23 hetao1733837 的刷题记录
c++·算法
java_nnnn11 小时前
LeetCode刷题滑动窗口(串联所有单词的子串+最小覆盖的子串)Java
算法·leetcode·职场和发展
Navigator_Z12 小时前
LeetCode //C - 1301. Number of Paths with Max Score
c语言·算法·leetcode
Interview Aid11212 小时前
Uber Interview Process 完整指南:面试流程、OA 真题与 VO 备考
面试·职场和发展